## GtkLabel GtkLabel — A widget that displays a small to medium amount of text |

## Functions

GtkWidget * | gtk_label_new ()
void | gtk_label_set_text ()
void | gtk_label_set_attributes ()
void | gtk_label_set_markup ()
void | gtk_label_set_markup_with_mnemonic ()
void | gtk_label_set_pattern ()
void | gtk_label_set_justify ()
void | gtk_label_set_xalign ()
void | gtk_label_set_yalign ()
void | gtk_label_set_ellipsize ()
void | gtk_label_set_width_chars ()
void | gtk_label_set_max_width_chars ()
void | gtk_label_set_line_wrap ()
void | gtk_label_set_line_wrap_mode ()
void | gtk_label_set_lines ()
void | gtk_label_get_layout_offsets ()
guint | gtk_label_get_mnemonic_keyval ()
gboolean | gtk_label_get_selectable ()
const gchar * | gtk_label_get_text ()
GtkWidget * | gtk_label_new_with_mnemonic ()
void | gtk_label_select_region ()
void | gtk_label_set_mnemonic_widget ()
void | gtk_label_set_selectable ()
void | gtk_label_set_text_with_mnemonic ()
PangoAttrList * | gtk_label_get_attributes ()
GtkJustification | gtk_label_get_justify ()
gfloat | gtk_label_get_xalign ()
gfloat | gtk_label_get_yalign ()
PangoEllipsizeMode | gtk_label_get_ellipsize ()
gint | gtk_label_get_width_chars ()
gint | gtk_label_get_max_width_chars ()
const gchar * | gtk_label_get_label ()
PangoLayout * | gtk_label_get_layout ()
gboolean | gtk_label_get_line_wrap ()
PangoWrapMode | gtk_label_get_line_wrap_mode ()
gint | gtk_label_get_lines ()
GtkWidget * | gtk_label_get_mnemonic_widget ()
gboolean | gtk_label_get_selection_bounds ()
gboolean | gtk_label_get_use_markup ()
gboolean | gtk_label_get_use_underline ()
gboolean | gtk_label_get_single_line_mode ()
gdouble | gtk_label_get_angle ()
void | gtk_label_set_label ()
void | gtk_label_set_use_markup ()
void | gtk_label_set_use_underline ()
void | gtk_label_set_single_line_mode ()
void | gtk_label_set_angle ()
const gchar * | gtk_label_get_current_uri ()
void | gtk_label_set_track_visited_links ()
gboolean | gtk_label_get_track_visited_links ()

## Properties

gdouble | angle | Read / Write
PangoAttrList * | attributes | Read / Write
gint | cursor-position | Read
PangoEllipsizeMode | ellipsize | Read / Write
GtkJustification | justify | Read / Write
gchar * | label | Read / Write
gint | lines | Read / Write
gint | max-width-chars | Read / Write
guint | mnemonic-keyval | Read
GtkWidget * | mnemonic-widget | Read / Write
gchar * | pattern | Write
gboolean | selectable | Read / Write
gint | selection-bound | Read
gboolean | single-line-mode | Read / Write
gboolean | track-visited-links | Read / Write
gboolean | use-markup | Read / Write
gboolean | use-underline | Read / Write
gint | width-chars | Read / Write
gboolean | wrap | Read / Write
PangoWrapMode | wrap-mode | Read / Write
gfloat | xalign | Read / Write
gfloat | yalign | Read / Write

## Signals

void | activate-current-link | Action
gboolean | activate-link | Run Last
void | copy-clipboard | Action
void | move-cursor | Action
void | populate-popup | Run Last

## Types and Values

struct | GtkLabel

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkWidget
                ╰── GtkMisc
                    ╰── GtkLabel
                        ╰── GtkAccelLabel

## Implemented Interfaces

GtkLabel implements AtkImplementor and GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

The GtkLabel widget displays a small amount of text. As the name implies, most labels are used to label another widget such as a GtkButton, a GtkMenuItem, or a GtkComboBox.

### CSS nodes

    label
    ├── [selection]
    ├── [link]
    ┊
    ╰── [link]

GtkLabel has a single CSS node with the name label. A wide variety of style classes may be applied to labels, such as .title, .subtitle, .dim-label, etc. In the GtkShortcutsWindow, labels are used wth the .keycap style class.

If the label has a selection, it gets a subnode with name selection.

If the label has links, there is one subnode per link. These subnodes carry the link or visited state depending on whether they have been visited.

### GtkLabel as GtkBuildable

The GtkLabel implementation of the GtkBuildable interface supports a custom <attributes> element, which supports any number of <attribute> elements. The <attribute> element has attributes named “name“, “value“, “start“ and “end“ and allows you to specify PangoAttribute values for this label.

An example of a UI definition fragment specifying Pango attributes:

    <object class="GtkLabel">
      <attributes>
        <attribute name="weight" value="PANGO_WEIGHT_BOLD"/>
        <attribute name="background" value="red" start="5" end="10"/>
      </attributes>
    </object>

The start and end attributes specify the range of characters to which the Pango attribute applies. If start and end are not specified, the attribute is applied to the whole text. Note that specifying ranges does not make much sense with translatable attributes. Use markup embedded in the translatable content instead.

### Mnemonics

Labels may contain “mnemonics”. Mnemonics are underlined characters in the label, used for keyboard navigation. Mnemonics are created by providing a string with an underscore before the mnemonic character, such as `"_File"`, to the functions `gtk_label_new_with_mnemonic()` or `gtk_label_set_text_with_mnemonic()`.

Mnemonics automatically activate any activatable widget the label is inside, such as a GtkButton; if the label is not inside the mnemonic’s target widget, you have to tell the label about the target using `gtk_label_set_mnemonic_widget()`. Here’s a simple example where the label is inside a button:

      // Pressing Alt+H will activate this button
      GtkWidget *button = gtk_button_new ();
      GtkWidget *label = gtk_label_new_with_mnemonic ("_Hello");
      gtk_container_add (GTK_CONTAINER (button), label);

There’s a convenience function to create buttons with a mnemonic label already inside:

      // Pressing Alt+H will activate this button
      GtkWidget *button = gtk_button_new_with_mnemonic ("_Hello");

To create a mnemonic for a widget alongside the label, such as a GtkEntry, you have to point the label at the entry with `gtk_label_set_mnemonic_widget()`:

      // Pressing Alt+H will focus the entry
      GtkWidget *entry = gtk_entry_new ();
      GtkWidget *label = gtk_label_new_with_mnemonic ("_Hello");
      gtk_label_set_mnemonic_widget (GTK_LABEL (label), entry);

### Markup (styled text)

To make it easy to format text in a label (changing colors, fonts, etc.), label text can be provided in a simple markup format.

Here’s how to create a label with a small font:

      GtkWidget *label = gtk_label_new (NULL);
      gtk_label_set_markup (GTK_LABEL (label), "<small>Small text</small>");

(See complete documentation of available tags in the Pango manual.)

The markup passed to `gtk_label_set_markup()` must be valid; for example, literal <, > and & characters must be escaped as <, >, and &. If you pass text obtained from the user, file, or a network to `gtk_label_set_markup()`, you’ll want to escape it with `g_markup_escape_text()` or `g_markup_printf_escaped()`.

Markup strings are just a convenient way to set the PangoAttrList on a label; `gtk_label_set_attributes()` may be a simpler way to set attributes in some cases. Be careful though; PangoAttrList tends to cause internationalization problems, unless you’re applying attributes to the entire string (i.e. unless you set the range of each attribute to [0, `G_MAXINT`)). The reason is that specifying the start_index and end_index for a PangoAttribute requires knowledge of the exact string being displayed, so translations will cause problems.

### Selectable labels

Labels can be made selectable with `gtk_label_set_selectable()`. Selectable labels allow the user to copy the label contents to the clipboard. Only labels that contain useful-to-copy information — such as error messages — should be made selectable.

### Text layout

A label can contain any number of paragraphs, but will have performance problems if it contains more than a small number. Paragraphs are separated by newlines or other paragraph separators understood by Pango.

Labels can automatically wrap text if you call `gtk_label_set_line_wrap()`.

gtk_label_set_justify() sets how the lines in a label align with one another. If you want to set how the label as a whole aligns in its available space, see the “halign” and “valign” properties.

The “width-chars” and “max-width-chars” properties can be used to control the size allocation of ellipsized or wrapped labels. For ellipsizing labels, if either is specified (and less than the actual text size), it is used as the minimum width, and the actual text size is used as the natural width of the label. For wrapping labels, width-chars is used as the minimum width, if specified, and max-width-chars is used as the natural width. Even if max-width-chars specified, wrapping labels will be rewrapped to use all of the available width.

Note that the interpretation of “width-chars” and “max-width-chars” has changed a bit with the introduction of width-for-height geometry management.

### Links

Since 2.18, GTK+ supports markup for clickable hyperlinks in addition to regular Pango markup. The markup for links is borrowed from HTML, using the `&lt;a>` with “href“ and “title“ attributes. GTK+ renders links similar to the way they appear in web browsers, with colored, underlined text. The “title“ attribute is displayed as a tooltip on the link.

An example looks like this:

    const gchar *text =
    "Go to the"
    "<a href=\"http://www.gtk.org title=\"<i>Our</i> website\">"
    "GTK+ website</a> for more...";
    GtkWidget *label = gtk_label_new (NULL);
    gtk_label_set_markup (GTK_LABEL (label), text);

It is possible to implement custom handling for links and their tooltips with the “activate-link” signal and the `gtk_label_get_current_uri()` function.

## Functions

### gtk_label_new ()

    GtkWidget *
    gtk_label_new (const gchar *str);

Creates a new label with the given text inside it. You can pass `NULL` to get an empty label widget.

#### Parameters

str | The text of the label. | [nullable]

#### Returns

the new GtkLabel

### gtk_label_set_text ()

    void
    gtk_label_set_text (GtkLabel *label,
                        const gchar *str);

Sets the text within the GtkLabel widget. It overwrites any text that was there before.

This function will clear any previously set mnemonic accelerators, and set the “use-underline” property to `FALSE` as a side effect.

This function will set the “use-markup” property to `FALSE` as a side effect.

See also: `gtk_label_set_markup()`

#### Parameters

label | a GtkLabel |
str | The text you want to set |

### gtk_label_set_attributes ()

    void
    gtk_label_set_attributes (GtkLabel *label,
                              PangoAttrList *attrs);

Sets a PangoAttrList; the attributes in the list are applied to the label text.

The attributes set with this function will be applied and merged with any other attributes previously effected by way of the “use-underline” or “use-markup” properties. While it is not recommended to mix markup strings with manually set attributes, if you must; know that the attributes will be applied to the label after the markup string is parsed.

#### Parameters

label | a GtkLabel |
attrs | a PangoAttrList, or `NULL`. | [nullable]

### gtk_label_set_markup ()

    void
    gtk_label_set_markup (GtkLabel *label,
                          const gchar *str);

Parses `str` which is marked up with the Pango text markup language, setting the label’s text and attribute list based on the parse results.

If the `str` is external data, you may need to escape it with `g_markup_escape_text()` or `g_markup_printf_escaped()`:

    GtkWidget *label = gtk_label_new (NULL);
    const char *str = "some text";
    const char *format = "<span style=\"italic\">\%s</span>";
    char *markup;

    markup = g_markup_printf_escaped (format, str);
    gtk_label_set_markup (GTK_LABEL (label), markup);
    g_free (markup);

This function will set the “use-markup” property to `TRUE` as a side effect.

If you set the label contents using the “label” property you should also ensure that you set the “use-markup” property accordingly.

See also: `gtk_label_set_text()`

#### Parameters

label | a GtkLabel |
str | a markup string (see Pango markup format) |

### gtk_label_set_markup_with_mnemonic ()

    void
    gtk_label_set_markup_with_mnemonic (GtkLabel *label,
                                        const gchar *str);

Parses `str` which is marked up with the Pango text markup language, setting the label’s text and attribute list based on the parse results. If characters in `str` are preceded by an underscore, they are underlined indicating that they represent a keyboard accelerator called a mnemonic.

The mnemonic key can be used to activate another widget, chosen automatically, or explicitly using `gtk_label_set_mnemonic_widget()`.

#### Parameters

label | a GtkLabel |
str | a markup string (see Pango markup format) |

### gtk_label_set_pattern ()

    void
    gtk_label_set_pattern (GtkLabel *label,
                           const gchar *pattern);

The pattern of underlines you want under the existing text within the GtkLabel widget. For example if the current text of the label says “FooBarBaz” passing a pattern of “___ ___” will underline “Foo” and “Baz” but not “Bar”.

#### Parameters

label | The GtkLabel you want to set the pattern to. |
pattern | The pattern as described above. |

### gtk_label_set_justify ()

    void
    gtk_label_set_justify (GtkLabel *label,
                           GtkJustification jtype);

Sets the alignment of the lines in the text of the label relative to each other. `GTK_JUSTIFY_LEFT` is the default value when the widget is first created with `gtk_label_new()`. If you instead want to set the alignment of the label as a whole, use `gtk_widget_set_halign()` instead. `gtk_label_set_justify()` has no effect on labels containing only a single line.

#### Parameters

label | a GtkLabel |
jtype | a GtkJustification |

### gtk_label_set_xalign ()

    void
    gtk_label_set_xalign (GtkLabel *label,
                          gfloat xalign);

Sets the “xalign” property for `label` .

#### Parameters

label | a GtkLabel |
xalign | the new xalign value, between 0 and 1 |

Since: 3.16

### gtk_label_set_yalign ()

    void
    gtk_label_set_yalign (GtkLabel *label,
                          gfloat yalign);

Sets the “yalign” property for `label` .

#### Parameters

label | a GtkLabel |
yalign | the new yalign value, between 0 and 1 |

Since: 3.16

### gtk_label_set_ellipsize ()

    void
    gtk_label_set_ellipsize (GtkLabel *label,
                             PangoEllipsizeMode mode);

Sets the mode used to ellipsize (add an ellipsis: "...") to the text if there is not enough space to render the entire string.

#### Parameters

label | a GtkLabel |
mode | a PangoEllipsizeMode |

Since: 2.6

### gtk_label_set_width_chars ()

    void
    gtk_label_set_width_chars (GtkLabel *label,
                               gint n_chars);

Sets the desired width in characters of `label` to `n_chars` .

#### Parameters

label | a GtkLabel |
n_chars | the new desired width, in characters. |

Since: 2.6

### gtk_label_set_max_width_chars ()

    void
    gtk_label_set_max_width_chars (GtkLabel *label,
                                   gint n_chars);

Sets the desired maximum width in characters of `label` to `n_chars` .

#### Parameters

label | a GtkLabel |
n_chars | the new desired maximum width, in characters. |

Since: 2.6

### gtk_label_set_line_wrap ()

    void
    gtk_label_set_line_wrap (GtkLabel *label,
                             gboolean wrap);

Toggles line wrapping within the GtkLabel widget. `TRUE` makes it break lines if text exceeds the widget’s size. `FALSE` lets the text get cut off by the edge of the widget if it exceeds the widget size.

Note that setting line wrapping to `TRUE` does not make the label wrap at its parent container’s width, because GTK+ widgets conceptually can’t make their requisition depend on the parent container’s size. For a label that wraps at a specific position, set the label’s width using `gtk_widget_set_size_request()`.

#### Parameters

label | a GtkLabel |
wrap | the setting |

### gtk_label_set_line_wrap_mode ()

    void
    gtk_label_set_line_wrap_mode (GtkLabel *label,
                                  PangoWrapMode wrap_mode);

If line wrapping is on (see `gtk_label_set_line_wrap()`) this controls how the line wrapping is done. The default is `PANGO_WRAP_WORD` which means wrap on word boundaries.

#### Parameters

label | a GtkLabel |
wrap_mode | the line wrapping mode |

Since: 2.10

### gtk_label_set_lines ()

    void
    gtk_label_set_lines (GtkLabel *label,
                         gint lines);

Sets the number of lines to which an ellipsized, wrapping label should be limited. This has no effect if the label is not wrapping or ellipsized. Set this to -1 if you don’t want to limit the number of lines.

#### Parameters

label | a GtkLabel |
lines | the desired number of lines, or -1 |

Since: 3.10

### gtk_label_get_layout_offsets ()

    void
    gtk_label_get_layout_offsets (GtkLabel *label,
                                  gint *x,
                                  gint *y);

Obtains the coordinates where the label will draw the PangoLayout representing the text in the label; useful to convert mouse events into coordinates inside the PangoLayout, e.g. to take some action if some part of the label is clicked. Of course you will need to create a GtkEventBox to receive the events, and pack the label inside it, since labels are windowless (they return `FALSE` from `gtk_widget_get_has_window()`). Remember when using the PangoLayout functions you need to convert to and from pixels using `PANGO_PIXELS()` or PANGO_SCALE.

#### Parameters

label | a GtkLabel |
x | location to store X offset of layout, or `NULL`. | [out][optional]
y | location to store Y offset of layout, or `NULL`. | [out][optional]

### gtk_label_get_mnemonic_keyval ()

    guint
    gtk_label_get_mnemonic_keyval (GtkLabel *label);

If the label has been set so that it has an mnemonic key this function returns the keyval used for the mnemonic accelerator. If there is no mnemonic set up it returns GDK_KEY_VoidSymbol.

#### Parameters

label | a GtkLabel |

#### Returns

GDK keyval usable for accelerators, or GDK_KEY_VoidSymbol

### gtk_label_get_selectable ()

    gboolean
    gtk_label_get_selectable (GtkLabel *label);

Gets the value set by `gtk_label_set_selectable()`.

#### Parameters

label | a GtkLabel |

#### Returns

`TRUE` if the user can copy text from the label

### gtk_label_get_text ()

    const gchar *
    gtk_label_get_text (GtkLabel *label);

Fetches the text from a label widget, as displayed on the screen. This does not include any embedded underlines indicating mnemonics or Pango markup. (See `gtk_label_get_label()`)

#### Parameters

label | a GtkLabel |

#### Returns

the text in the label widget. This is the internal string used by the label, and must not be modified.

### gtk_label_new_with_mnemonic ()

    GtkWidget *
    gtk_label_new_with_mnemonic (const gchar *str);

Creates a new GtkLabel, containing the text in `str` .

If characters in `str` are preceded by an underscore, they are underlined. If you need a literal underscore character in a label, use '__' (two underscores). The first underlined character represents a keyboard accelerator called a mnemonic. The mnemonic key can be used to activate another widget, chosen automatically, or explicitly using `gtk_label_set_mnemonic_widget()`.

If `gtk_label_set_mnemonic_widget()` is not called, then the first activatable ancestor of the GtkLabel will be chosen as the mnemonic widget. For instance, if the label is inside a button or menu item, the button or menu item will automatically become the mnemonic widget and be activated by the mnemonic.

#### Parameters

str | The text of the label, with an underscore in front of the mnemonic character. | [nullable]

#### Returns

the new GtkLabel

### gtk_label_select_region ()

    void
    gtk_label_select_region (GtkLabel *label,
                             gint start_offset,
                             gint end_offset);

Selects a range of characters in the label, if the label is selectable. See `gtk_label_set_selectable()`. If the label is not selectable, this function has no effect. If `start_offset` or `end_offset` are -1, then the end of the label will be substituted.

#### Parameters

label | a GtkLabel |
start_offset | start offset (in characters not bytes) |
end_offset | end offset (in characters not bytes) |

### gtk_label_set_mnemonic_widget ()

    void
    gtk_label_set_mnemonic_widget (GtkLabel *label,
                                   GtkWidget *widget);

If the label has been set so that it has an mnemonic key (using i.e. `gtk_label_set_markup_with_mnemonic()`, `gtk_label_set_text_with_mnemonic()`, `gtk_label_new_with_mnemonic()` or the “use_underline” property) the label can be associated with a widget that is the target of the mnemonic. When the label is inside a widget (like a GtkButton or a GtkNotebook tab) it is automatically associated with the correct widget, but sometimes (i.e. when the target is a GtkEntry next to the label) you need to set it explicitly using this function.

The target widget will be accelerated by emitting the GtkWidget::mnemonic-activate signal on it. The default handler for this signal will activate the widget if there are no mnemonic collisions and toggle focus between the colliding widgets otherwise.

#### Parameters

label | a GtkLabel |
widget | the target GtkWidget, or `NULL` to unset. | [nullable]

### gtk_label_set_selectable ()

    void
    gtk_label_set_selectable (GtkLabel *label,
                              gboolean setting);

Selectable labels allow the user to select text from the label, for copy-and-paste.

#### Parameters

label | a GtkLabel |
setting | `TRUE` to allow selecting text in the label |

### gtk_label_set_text_with_mnemonic ()

    void
    gtk_label_set_text_with_mnemonic (GtkLabel *label,
                                      const gchar *str);

Sets the label’s text from the string `str` . If characters in `str` are preceded by an underscore, they are underlined indicating that they represent a keyboard accelerator called a mnemonic. The mnemonic key can be used to activate another widget, chosen automatically, or explicitly using `gtk_label_set_mnemonic_widget()`.

#### Parameters

label | a GtkLabel |
str | a string |

### gtk_label_get_attributes ()

    PangoAttrList *
    gtk_label_get_attributes (GtkLabel *label);

Gets the attribute list that was set on the label using `gtk_label_set_attributes()`, if any. This function does not reflect attributes that come from the labels markup (see `gtk_label_set_markup()`). If you want to get the effective attributes for the label, use pango_layout_get_attribute (gtk_label_get_layout (label)).

#### Parameters

label | a GtkLabel |

#### Returns

the attribute list, or `NULL` if none was set.

[nullable][transfer none]

### gtk_label_get_justify ()

    GtkJustification
    gtk_label_get_justify (GtkLabel *label);

Returns the justification of the label. See `gtk_label_set_justify()`.

#### Parameters

label | a GtkLabel |

#### Returns

GtkJustification

### gtk_label_get_xalign ()

    gfloat
    gtk_label_get_xalign (GtkLabel *label);

Gets the “xalign” property for `label` .

#### Parameters

label | a GtkLabel |

#### Returns

the xalign property

Since: 3.16

### gtk_label_get_yalign ()

    gfloat
    gtk_label_get_yalign (GtkLabel *label);

Gets the “yalign” property for `label` .

#### Parameters

label | a GtkLabel |

#### Returns

the yalign property

Since: 3.16

### gtk_label_get_ellipsize ()

    PangoEllipsizeMode
    gtk_label_get_ellipsize (GtkLabel *label);

Returns the ellipsizing position of the label. See `gtk_label_set_ellipsize()`.

#### Parameters

label | a GtkLabel |

#### Returns

PangoEllipsizeMode

Since: 2.6

### gtk_label_get_width_chars ()

    gint
    gtk_label_get_width_chars (GtkLabel *label);

Retrieves the desired width of `label` , in characters. See `gtk_label_set_width_chars()`.

#### Parameters

label | a GtkLabel |

#### Returns

the width of the label in characters.

Since: 2.6

### gtk_label_get_max_width_chars ()

    gint
    gtk_label_get_max_width_chars (GtkLabel *label);

Retrieves the desired maximum width of `label` , in characters. See `gtk_label_set_width_chars()`.

#### Parameters

label | a GtkLabel |

#### Returns

the maximum width of the label in characters.

Since: 2.6

### gtk_label_get_label ()

    const gchar *
    gtk_label_get_label (GtkLabel *label);

Fetches the text from a label widget including any embedded underlines indicating mnemonics and Pango markup. (See `gtk_label_get_text()`).

#### Parameters

label | a GtkLabel |

#### Returns

the text of the label widget. This string is owned by the widget and must not be modified or freed.

### gtk_label_get_layout ()

    PangoLayout *
    gtk_label_get_layout (GtkLabel *label);

Gets the PangoLayout used to display the label. The layout is useful to e.g. convert text positions to pixel positions, in combination with `gtk_label_get_layout_offsets()`. The returned layout is owned by the `label` so need not be freed by the caller. The `label` is free to recreate its layout at any time, so it should be considered read-only.

#### Parameters

label | a GtkLabel |

#### Returns

the PangoLayout for this label.

[transfer none]

### gtk_label_get_line_wrap ()

    gboolean
    gtk_label_get_line_wrap (GtkLabel *label);

Returns whether lines in the label are automatically wrapped. See `gtk_label_set_line_wrap()`.

#### Parameters

label | a GtkLabel |

#### Returns

`TRUE` if the lines of the label are automatically wrapped.

### gtk_label_get_line_wrap_mode ()

    PangoWrapMode
    gtk_label_get_line_wrap_mode (GtkLabel *label);

Returns line wrap mode used by the label. See `gtk_label_set_line_wrap_mode()`.

#### Parameters

label | a GtkLabel |

#### Returns

`TRUE` if the lines of the label are automatically wrapped.

Since: 2.10

### gtk_label_get_lines ()

    gint
    gtk_label_get_lines (GtkLabel *label);

Gets the number of lines to which an ellipsized, wrapping label should be limited. See `gtk_label_set_lines()`.

#### Parameters

label | a GtkLabel |

#### Returns

The number of lines

Since: 3.10

### gtk_label_get_mnemonic_widget ()

    GtkWidget *
    gtk_label_get_mnemonic_widget (GtkLabel *label);

Retrieves the target of the mnemonic (keyboard shortcut) of this label. See `gtk_label_set_mnemonic_widget()`.

#### Parameters

label | a GtkLabel |

#### Returns

the target of the label’s mnemonic, or `NULL` if none has been set and the default algorithm will be used.

[nullable][transfer none]

### gtk_label_get_selection_bounds ()

    gboolean
    gtk_label_get_selection_bounds (GtkLabel *label,
                                    gint *start,
                                    gint *end);

Gets the selected range of characters in the label, returning `TRUE` if there’s a selection.

#### Parameters

label | a GtkLabel |
start | return location for start of selection, as a character offset. | [out]
end | return location for end of selection, as a character offset. | [out]

#### Returns

`TRUE` if selection is non-empty

### gtk_label_get_use_markup ()

    gboolean
    gtk_label_get_use_markup (GtkLabel *label);

Returns whether the label’s text is interpreted as marked up with the Pango text markup language. See `gtk_label_set_use_markup()`.

#### Parameters

label | a GtkLabel |

#### Returns

`TRUE` if the label’s text will be parsed for markup.

### gtk_label_get_use_underline ()

    gboolean
    gtk_label_get_use_underline (GtkLabel *label);

Returns whether an embedded underline in the label indicates a mnemonic. See `gtk_label_set_use_underline()`.

#### Parameters

label | a GtkLabel |

#### Returns

`TRUE` whether an embedded underline in the label indicates the mnemonic accelerator keys.

### gtk_label_get_single_line_mode ()

    gboolean
    gtk_label_get_single_line_mode (GtkLabel *label);

Returns whether the label is in single line mode.

#### Parameters

label | a GtkLabel |

#### Returns

`TRUE` when the label is in single line mode.

Since: 2.6

### gtk_label_get_angle ()

    gdouble
    gtk_label_get_angle (GtkLabel *label);

Gets the angle of rotation for the label. See `gtk_label_set_angle()`.

#### Parameters

label | a GtkLabel |

#### Returns

the angle of rotation for the label

Since: 2.6

### gtk_label_set_label ()

    void
    gtk_label_set_label (GtkLabel *label,
                         const gchar *str);

Sets the text of the label. The label is interpreted as including embedded underlines and/or Pango markup depending on the values of the “use-underline” and “use-markup” properties.

#### Parameters

label | a GtkLabel |
str | the new text to set for the label |

### gtk_label_set_use_markup ()

    void
    gtk_label_set_use_markup (GtkLabel *label,
                              gboolean setting);

Sets whether the text of the label contains markup in Pango’s text markup language. See `gtk_label_set_markup()`.

#### Parameters

label | a GtkLabel |
setting | `TRUE` if the label’s text should be parsed for markup. |

### gtk_label_set_use_underline ()

    void
    gtk_label_set_use_underline (GtkLabel *label,
                                 gboolean setting);

If true, an underline in the text indicates the next character should be used for the mnemonic accelerator key.

#### Parameters

label | a GtkLabel |
setting | `TRUE` if underlines in the text indicate mnemonics |

### gtk_label_set_single_line_mode ()

    void
    gtk_label_set_single_line_mode (GtkLabel *label,
                                    gboolean single_line_mode);

Sets whether the label is in single line mode.

#### Parameters

label | a GtkLabel |
single_line_mode | `TRUE` if the label should be in single line mode |

Since: 2.6

### gtk_label_set_angle ()

    void
    gtk_label_set_angle (GtkLabel *label,
                         gdouble angle);

Sets the angle of rotation for the label. An angle of 90 reads from from bottom to top, an angle of 270, from top to bottom. The angle setting for the label is ignored if the label is selectable, wrapped, or ellipsized.

#### Parameters

label | a GtkLabel |
angle | the angle that the baseline of the label makes with the horizontal, in degrees, measured counterclockwise |

Since: 2.6

### gtk_label_get_current_uri ()

    const gchar *
    gtk_label_get_current_uri (GtkLabel *label);

Returns the URI for the currently active link in the label. The active link is the one under the mouse pointer or, in a selectable label, the link in which the text cursor is currently positioned.

This function is intended for use in a “activate-link” handler or for use in a “query-tooltip” handler.

#### Parameters

label | a GtkLabel |

#### Returns

the currently active URI. The string is owned by GTK+ and must not be freed or modified.

Since: 2.18

### gtk_label_set_track_visited_links ()

    void
    gtk_label_set_track_visited_links (GtkLabel *label,
                                       gboolean track_links);

Sets whether the label should keep track of clicked links (and use a different color for them).

#### Parameters

label | a GtkLabel |
track_links | `TRUE` to track visited links |

Since: 2.18

### gtk_label_get_track_visited_links ()

    gboolean
    gtk_label_get_track_visited_links (GtkLabel *label);

Returns whether the label is currently keeping track of clicked links.

#### Parameters

label | a GtkLabel |

#### Returns

`TRUE` if clicked links are remembered

Since: 2.18

## Types and Values

### struct GtkLabel

    struct GtkLabel;

## Property Details

### The `“angle”` property

      “angle”                    gdouble

The angle that the baseline of the label makes with the horizontal, in degrees, measured counterclockwise. An angle of 90 reads from from bottom to top, an angle of 270, from top to bottom. Ignored if the label is selectable.

Flags: Read / Write

Allowed values: [0,360]

Default value: 0

Since: 2.6

### The `“attributes”` property

      “attributes”               PangoAttrList *

A list of style attributes to apply to the text of the label.

Flags: Read / Write

### The `“cursor-position”` property

      “cursor-position”          gint

The current position of the insertion cursor in chars.

Flags: Read

Allowed values: >= 0

Default value: 0

### The `“ellipsize”` property

      “ellipsize”                PangoEllipsizeMode

The preferred place to ellipsize the string, if the label does not have enough room to display the entire string, specified as a PangoEllipsizeMode.

Note that setting this property to a value other than `PANGO_ELLIPSIZE_NONE` has the side-effect that the label requests only enough space to display the ellipsis "...". In particular, this means that ellipsizing labels do not work well in notebook tabs, unless the GtkNotebook tab-expand child property is set to `TRUE`. Other ways to set a label's width are `gtk_widget_set_size_request()` and `gtk_label_set_width_chars()`.

Flags: Read / Write

Default value: PANGO_ELLIPSIZE_NONE

Since: 2.6

### The `“justify”` property

      “justify”                  GtkJustification

The alignment of the lines in the text of the label relative to each other. This does NOT affect the alignment of the label within its allocation. See GtkLabel:xalign for that.

Flags: Read / Write

Default value: GTK_JUSTIFY_LEFT

### The `“label”` property

      “label”                    gchar *

The contents of the label.

If the string contains Pango XML markup, you will have to set the “use-markup” property to `TRUE` in order for the label to display the markup attributes. See also `gtk_label_set_markup()` for a convenience function that sets both this property and the “use-markup” property at the same time.

If the string contains underlines acting as mnemonics, you will have to set the “use-underline” property to `TRUE` in order for the label to display them.

Flags: Read / Write

Default value: ""

### The `“lines”` property

      “lines”                    gint

The number of lines to which an ellipsized, wrapping label should be limited. This property has no effect if the label is not wrapping or ellipsized. Set this property to -1 if you don't want to limit the number of lines.

Flags: Read / Write

Allowed values: >= -1

Default value: -1

Since: 3.10

### The `“max-width-chars”` property

      “max-width-chars”          gint

The desired maximum width of the label, in characters. If this property is set to -1, the width will be calculated automatically.

See the section on text layout for details of how “width-chars” and “max-width-chars” determine the width of ellipsized and wrapped labels.

Flags: Read / Write

Allowed values: >= -1

Default value: -1

Since: 2.6

### The `“mnemonic-keyval”` property

      “mnemonic-keyval”          guint

The mnemonic accelerator key for this label.

Flags: Read

Default value: 16777215

### The `“mnemonic-widget”` property

      “mnemonic-widget”          GtkWidget *

The widget to be activated when the label's mnemonic key is pressed.

Flags: Read / Write

### The `“pattern”` property

      “pattern”                  gchar *

A string with _ characters in positions correspond to characters in the text to underline.

Flags: Write

Default value: NULL

### The `“selectable”` property

      “selectable”               gboolean

Whether the label text can be selected with the mouse.

Flags: Read / Write

Default value: FALSE

### The `“selection-bound”` property

      “selection-bound”          gint

The position of the opposite end of the selection from the cursor in chars.

Flags: Read

Allowed values: >= 0

Default value: 0

### The `“single-line-mode”` property

      “single-line-mode”         gboolean

Whether the label is in single line mode. In single line mode, the height of the label does not depend on the actual text, it is always set to ascent + descent of the font. This can be an advantage in situations where resizing the label because of text changes would be distracting, e.g. in a statusbar.

Flags: Read / Write

Default value: FALSE

Since: 2.6

### The `“track-visited-links”` property

      “track-visited-links”      gboolean

Set this property to `TRUE` to make the label track which links have been visited. It will then apply the GTK_STATE_FLAG_VISITED when rendering this link, in addition to GTK_STATE_FLAG_LINK.

Flags: Read / Write

Default value: TRUE

Since: 2.18

### The `“use-markup”` property

      “use-markup”               gboolean

The text of the label includes XML markup. See pango_parse_markup().

Flags: Read / Write

Default value: FALSE

### The `“use-underline”` property

      “use-underline”            gboolean

If set, an underline in the text indicates the next character should be used for the mnemonic accelerator key.

Flags: Read / Write

Default value: FALSE

### The `“width-chars”` property

      “width-chars”              gint

The desired width of the label, in characters. If this property is set to -1, the width will be calculated automatically.

See the section on text layout for details of how “width-chars” and “max-width-chars” determine the width of ellipsized and wrapped labels.

Flags: Read / Write

Allowed values: >= -1

Default value: -1

Since: 2.6

### The `“wrap”` property

      “wrap”                     gboolean

If set, wrap lines if the text becomes too wide.

Flags: Read / Write

Default value: FALSE

### The `“wrap-mode”` property

      “wrap-mode”                PangoWrapMode

If line wrapping is on (see the “wrap” property) this controls how the line wrapping is done. The default is `PANGO_WRAP_WORD`, which means wrap on word boundaries.

Flags: Read / Write

Default value: PANGO_WRAP_WORD

Since: 2.10

### The `“xalign”` property

      “xalign”                   gfloat

The xalign property determines the horizontal aligment of the label text inside the labels size allocation. Compare this to “halign”, which determines how the labels size allocation is positioned in the space available for the label.

Flags: Read / Write

Allowed values: [0,1]

Default value: 0.5

Since: 3.16

### The `“yalign”` property

      “yalign”                   gfloat

The yalign property determines the vertical aligment of the label text inside the labels size allocation. Compare this to “valign”, which determines how the labels size allocation is positioned in the space available for the label.

Flags: Read / Write

Allowed values: [0,1]

Default value: 0.5

Since: 3.16

## Signal Details

### The `“activate-current-link”` signal

    void
    user_function (GtkLabel *label,
                   gpointer  user_data)

A keybinding signal which gets emitted when the user activates a link in the label.

Applications may also emit the signal with `g_signal_emit_by_name()` if they need to control activation of URIs programmatically.

The default bindings for this signal are all forms of the Enter key.

#### Parameters

label | The label on which the signal was emitted |
user_data | user data set when the signal handler was connected. |

Flags: Action

Since: 2.18

### The `“activate-link”` signal

    gboolean
    user_function (GtkLabel *label,
                   gchar    *uri,
                   gpointer  user_data)

The signal which gets emitted to activate a URI. Applications may connect to it to override the default behaviour, which is to call `gtk_show_uri_on_window()`.

#### Parameters

label | The label on which the signal was emitted |
uri | the URI that is activated |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the link has been activated

Flags: Run Last

Since: 2.18

### The `“copy-clipboard”` signal

    void
    user_function (GtkLabel *label,
                   gpointer  user_data)

The ::copy-clipboard signal is a keybinding signal which gets emitted to copy the selection to the clipboard.

The default binding for this signal is Ctrl-c.

#### Parameters

label | the object which received the signal |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“move-cursor”` signal

    void
    user_function (GtkLabel       *entry,
                   GtkMovementStep step,
                   gint            count,
                   gboolean        extend_selection,
                   gpointer        user_data)

The ::move-cursor signal is a keybinding signal which gets emitted when the user initiates a cursor movement. If the cursor is not visible in `entry` , this signal causes the viewport to be moved instead.

Applications should not connect to it, but may emit it with `g_signal_emit_by_name()` if they need to control the cursor programmatically.

The default bindings for this signal come in two variants, the variant with the Shift modifier extends the selection, the variant without the Shift modifer does not. There are too many key combinations to list them all here.

- Arrow keys move by individual characters/lines

- Ctrl-arrow key combinations move by words/paragraphs

- Home/End keys move to the ends of the buffer

#### Parameters

entry | the object which received the signal |
step | the granularity of the move, as a GtkMovementStep |
count | the number of `step` units to move |
extend_selection | `TRUE` if the move should extend the selection |
user_data | user data set when the signal handler was connected. |

Flags: Action

### The `“populate-popup”` signal

    void
    user_function (GtkLabel *label,
                   GtkMenu  *menu,
                   gpointer  user_data)

The ::populate-popup signal gets emitted before showing the context menu of the label. Note that only selectable labels have context menus.

If you need to add items to the context menu, connect to this signal and append your menuitems to the `menu` .

#### Parameters

label | The label on which the signal is emitted |
menu | the menu that is being populated |
user_data | user data set when the signal handler was connected. |

Flags: Run Last